/*
 * $Id: grapherrormsg.c,v 0.1 1993/12/10 00:37:39 king Exp king $
 * Returns a pointer to an error message string.
 *
 * $Log: grapherrormsg.c,v $
 * Revision 0.1  1993/12/10  00:37:39  king
 * Initial version.
 *
 */
#include <stdio.h>
#include <string.h>
#include "graphics.h"

const char *grapherrormsg(int errorcode)
{
	enum graphics_errors gr_error;
	const char *errormsg = "Unknown error";

	gr_error = errorcode;
	switch (gr_error) {
		case grOk:
			errormsg = "No error";
			break;
		case grNoInitGraph:
			errormsg =
			      "XBGI graphics not installed (use initgraph()).";
			break;
		case grNotDetected:
			errormsg = "Graphics hardware not detected.";
			break;
		case grFileNotFound:
			errormsg = "Device driver file not found.";
			break;
		case grInvalidDriver:
			errormsg = "Invalid device driver file.";
			break;
		case grNoLoadMem:
			errormsg = "Not enough memory to load driver.";
			break;
		case grNoScanMem:
			errormsg = "Out of memory in scan fill.";
			break;
		case grNoFloodMem:
			errormsg = "Out of memory in flood fill.";
			break;
		case grFontNotFound:
			errormsg = "Font file not found.";
			break;
		case grNoFontMem:
			errormsg = "Not enough memory to load font.";
			break;
		case grInvalidMode:
			errormsg = "Invalid graphics mode for"
				    "selected driver.";
			break;
		case grError:
			errormsg = "Graphics error.";
			break;
		case grIOerror:
			errormsg = "Graphics I/O error.";
			break;
		case grInvalidFont:
			errormsg = "Invalid font file.";
			break;
		case grInvalidFontNum:
			errormsg = "Invalid font number.";
			break;
		case grInvalidDeviceNum:
			errormsg = "Invalid device number.";
			break;
		case grInvalidVersion:
			errormsg = "Invalid version of file.";
			break;
		default:
			break;
	}

	return (errormsg);
}
